<!-- 订单管理-我的履约-延期申请 -->
<template>
    <app-drawer title="延期申请" :width="480" v-model:show="show" :loading="loading" :refresh="refresh">
        <el-form ref="formRef" label-width="110px" :model="formData" :rules="formRules">
            <el-form-item label="关联单号">
                <span>{{ selectedRow.relatedorderid }}</span>
            </el-form-item>
            <el-form-item label="当前步骤">
                <span>{{ getStepTypeName(selectedRow.steptypeid) }}</span>
            </el-form-item>
            <el-form-item label="申请延期天数" prop="delaydays">
                <el-input type="number" placeholder="请输入" v-model.number="formData.delaydays" />
            </el-form-item>
            <el-form-item label="备注" prop="applyremark">
                <el-input type="textarea" :rows="3" v-model="formData.applyremark" />
            </el-form-item>
        </el-form>
        <template #footer>
            <el-button @click="onCancel(false)" plain>取消</el-button>
            <el-button type="primary" @click="onSubmit">确认</el-button>
        </template>
    </app-drawer>
</template>

<script lang="ts" setup>
import { ref, PropType } from 'vue'
import { ElMessage } from 'element-plus'
import type { FormInstance, FormRules } from 'element-plus'
import { getStepTypeName } from '@/constants/order'
import { usePerformanceDelay } from '@/business/order'
import AppDrawer from '@pc/components/base/drawer/index.vue'

const props = defineProps({
    selectedRow: {
        type: Object as PropType<Ermcp.MyPerformancRsp>,
        default: () => ({})
    }
})

const { loading, formData, formSubmit } = usePerformanceDelay(props.selectedRow)
const show = ref(true)
const refresh = ref(false)
const formRef = ref<FormInstance>()

const formRules: FormRules = {
    delaydays: [{ required: true, message: '请输入延期天数', trigger: 'blur' }],
}

const onCancel = (isRefresh = false) => {
    show.value = false
    refresh.value = isRefresh
}

const onSubmit = () => {
    formRef.value?.validate((valid) => {
        if (valid) {
            formSubmit().then(() => {
                ElMessage.success('提交成功')
                onCancel(true)
            }).catch((err) => {
                ElMessage.error('提交失败：' + err)
            })
        }
    })
}
</script>